local L = LibStub("AceLocale-3.0"):GetLocale("GigaItemAuction", false)

local _G				= getfenv(0)

local pairs			    = _G.pairs
local ipairs			= _G.ipairs
local select			= _G.select

local table_insert		= _G.table.insert
local table_remove		= _G.table.remove
local table_sort		= _G.table.sort

local PLAYERNAME 		= UnitName("player")

local db

function GigaItemAuction:FILTEROnInitialize()
	db = self.db.profile
end

local LocalFilterDBVariable = {
	itemType = {
		[L["Weapon"]] 			= "Weapon",
		[L["Armor"]] 			= "Armor",
		[L["Gem"]] 				= "Gem",
		[L["Trade Goods"]] 		= "Trade_Goods",
		[L["Recipe"]] 			= "Recipe",
		[L["Miscellaneous"]] 	= "Miscellaneous",
	},
	itemSubType = {
		--armor
		[L["Miscellaneous"]]		= "Miscellaneous",
		[L["Plate"]] 				= "Plate",
		[L["Mail"]] 				= "Mail",
		[L["Leather"]] 				= "Leather",
		[L["Cloth"]] 				= "Cloth",
		[L["Shields"]]				= "Shields",
		[L["Librams"]]				= "Librams",
		[L["Idols"]]				= "Idols",
		[L["Totems"]]				= "Totems",
		[L["Sigils"]]				= "Sigils",
		--Miscellaneous
		[L["Junk"]]					= "Junk",
		--gems
		[L["Red"]]					= "Red",
		[L["Blue"]]					= "Blue",
		[L["Yellow"]]				= "Yellow",
		[L["Purple"]]				= "Purple",
		[L["Green"]]				= "Green",
		[L["Orange"]]				= "Orange",
		--recipe
		[L["Leatherworking"]] 		= "Leatherworking",
		[L["Tailoring"]] 			= "Tailoring",
		[L["Engineering"]] 			= "Engineering",
		[L["Blacksmithing"]] 		= "Blacksmithing",
		[L["Jewelcrafting"]] 		= "Jewelcrafting",
		[L["Enchanting"]] 			= "Enchanting",
		[L["Alchemy"]] 				= "Alchemy",
	},
}


function GigaItemAuction:ItemFilterCheck(itemType, itemSubType, itemEquipLoc)

	if db.config.debugadmin then
		self:Print("|cff5555ffDEBUG:|r FilterINC - |cff55ff55itemType|r "..(itemType or "-"))
		self:Print("|cff5555ffDEBUG:|r FilterINC - |cff55ff55itemSubType|r "..(itemSubType or "-"))
		self:Print("|cff5555ffDEBUG:|r FilterINC - |cff55ff55itemEquipLoc|r "..(itemEquipLoc or "-"))
	end
	
	local dbit = db.filter.itemType
	local dbst = db.filter.itemSubType
	local dbel = db.filter.itemEquipLoc
	local lfdbv = LocalFilterDBVariable
	local auction = false
	
	if db.config.debugadmin then
		self:Print("|cff5555ffDEBUG:|r FilterVAR - |cff5555ffitemType|r "..(lfdbv.itemType[itemType] or "-"))
		self:Print("|cff5555ffDEBUG:|r FilterVAR - |cff5555ffitemSubType|r "..(lfdbv.itemSubType[itemSubType] or "-"))
	end

	
	if dbit.showAll then 
		auction = true
	elseif dbit[lfdbv.itemType[itemType]] then
		if itemType == L["Trade Goods"] or itemType == L["Miscellaneous"] then
			auction = true
			
		elseif itemType == L["Weapon"] then
			auction = true
			
		elseif itemType == L["Armor"] then
			if (itemSubType ~= L["Librams"] and itemSubType ~= L["Idols"] and itemSubType ~= L["Totems"] and itemSubType ~= L["Sigils"]) and dbst[lfdbv.itemSubType[itemSubType]] then
				if dbel[itemEquipLoc] then
					auction = true
				end
			elseif (itemSubType == L["Librams"] or itemSubType == L["Idols"] or itemSubType == L["Totems"] or itemSubType == L["Sigils"]) and dbst.other_Relic and dbst[lfdbv.itemSubType[itemSubType]] then
				auction = true
			end
		elseif itemType == L["Gem"] then
			if dbst[lfdbv.itemSubType[itemSubType]] or (not lfdbv.itemSubType[itemSubType] and dbst.other_Recipe) then
				auction = true
			end
		elseif itemType == L["Recipe"] then
			if dbst[lfdbv.itemSubType[itemSubType]] or (not lfdbv.itemSubType[itemSubType] and dbst.other_Gem) then
				auction = true
			end
		end
	end

	if db.config.debugadmin then
		self:Print("|cff5555ffDEBUG:|r FilterOUT - |cffff5555Need|r "..(auction and "YES" or "NO"))
	end
	
	return auction
end


